/*
 * a-tools.c:
 * some tools from herbert attenberger <herbsl@a-land.de>
 */

#include "a-tools.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>


char *strsub(char *s, int p, int n)
{
        char *s1 = NULL;
        
        if (s == NULL)
                return NULL;
        
        int l = strlen(s);
        if (p > l || p < 1 || n < 1)
                return NULL;
        
        if (p + n > l + 1)
                n = l - p + 1;
        
        s = s + p - 1;
        
        s1 = (char*) malloc(sizeof(char) * (n + 1));
        if (s1) {
                memmove(s1, s, sizeof(char) * n);
                s1[n] = '\0';
                
                return s1;
        }
        else
                return NULL;
} 


char *strcol(char *s, char *d, int c)
{
        char *s1, *s2;
        int i;
        int l, l1;
        
        if (s == NULL || d == NULL || c < 1)
                return NULL;
        
        l = strlen(d);
        
        for (i = 1; i < c; i++) {
                s = strstr(s, d);
                if (s == NULL)
                        return NULL;
                s = s + l;
        }
        
        s1 = strstr(s, d);
        if (s1 == NULL) {
                s1 = strchr(s, '\n');
                if (s1 == NULL)
                        s1 = strchr(s,'\0');
        }
        
        l1 = s1 -s;
        
        s2 = (char*) malloc(sizeof(char) * (l1 + 1));
        memmove(s2, s, sizeof(char) * l1);
        s2[l1] = '\0';
        
        return s2;
}


int strnumcol(char *s, char *d)
{
        char *s1;
        int i, l;
        
        if (s == NULL || d == NULL)
                return 0;
        
        i = 1;
        l = strlen(d);
        
        s1 = strstr(s, d);
        while (s1 != NULL) {
                i++;
                s1 = s1 + l;
                s1 = strstr(s1, d);
        }
        
        return i;
}


char *strgrep(char *s, FILE *f)
{
        char *s1 = "";
        size_t i = 0;
        
        if (s == NULL)
                return NULL;
        
        while (strstr(s1, s) == NULL) {
                if (getline(&s1, &i, f) == -1)
                        return NULL;
        }
        
        return s1;
}


int strcmp0(char *s1, char *s2)
{
        if (s1 == NULL && s2 == NULL)
                return 0;
        else if (s1 == NULL || s2 == NULL)
                return -1;
        else
                return strcmp(s1, s2);
}


char *strdup0(char *s)
{
        if (s == NULL)
                return NULL;
        
        return strdup(s);
}


char *strdup0(const char *s)
{
        if (s == NULL)
                return NULL;
        
        return strdup(s);
}

void strtr(char *s)
{
        unsigned int c;
        
        /* replace ' ' with '_', and '/' with ',' */
        for (c = 0; c < strlen(s); c++) {
                if (s[c] == ' ')
                        s[c] = '_';
		else if (s[c] == '/')
			s[c] = ',';
        }
}
