/*
 * audioreceiver.h
 */

#ifndef __AUDIORECEIVER_H
#define __AUDIORECEIVER_H

#include "track.h"
#include "postdata.h"
#include "rds.h"
#include "mpa-frame.h"
#include "recstat.h"
#include "a-tools.h"

#include <vdr/receiver.h>
#include <vdr/ringbuffer.h>
#include <vdr/channels.h>


class cAudioReceiver : public cReceiver, cThread {
private:
        bool active;
        int device_number;
        
        cRingBufferLinear *buffer;
        const cChannel *channel;
        
        cTrack *track;
        cPostData *postdata;
        cRds *rds;
        
        eRecStat recstat;
        mpeg_audio_frame mpa_frame;
        bool pes_sync;
        
        void set_recstat_rds(void);
        void control_track(void);
        char *get_path();
        char *get_comment();
protected:
        virtual void Receive(uchar *data, int length);
        
        virtual void Action(void);
        virtual void Activate(bool on);
public:
        cAudioReceiver(const cChannel *chan);
        ~cAudioReceiver();
        
        void set_device_number(int _device_number) { device_number =
                _device_number; }
        int get_device_number(void) { return device_number; }
        bool is_attached(int attached_device_number);
	/*
	 * return true if the receiver is attached to the given device.
	 * if attached_device_number == -1, true is returned if the
	 * receiver is attached to a device
         */
        bool is_recording(void);
        const cChannel *get_channel(void) { return channel; }
};

#endif /* __AUDIORECEIVER_H */
