/*
 * postdata.h
 */

#ifndef __POSTDATA_H
#define __POSTDATA_H

class cPostData {
private:
        char *title;
        char *artist;
        char *genre;
        char *comment;
        
        char *codec;
        int bit_rate;
        int sample_rate;
        int channels;
        int frame_len;
        
        int len_mpa_frame;
        
        int fade_in_mode;
        int frames_fade_in;
        int fade_out_mode;
        int frames_fade_out;
        
        char *path;
        char *new_path;
        
        cPostData *next;
        
        void reset();
        void set_fade_values();
        void set_new_path();
public:
	cPostData(void);
	~cPostData();
        cPostData(const cPostData *postdata);
        
        void new_track(char *_path, char *_comment);
        void stop_track(int _bit_rate, int _sample_rate, int _channels,
                int _len_mpa_frame);
        
        void set_title(char *_title);
        void set_artist(char *_artist);
        void set_genre(int);
        void set_genre(char *_genre);
        
        char *get_title(void) const { return title; }
        char *get_artist(void) const { return artist; }
        char *get_genre(void) const { return genre; }
        char *get_comment(void) const { return comment; }
        
        char *get_codec(void) const { return codec; }
        int get_bit_rate(void) const { return bit_rate; }
        int get_sample_rate(void) const { return sample_rate; }
        int get_channels(void) const { return channels; }
        
        int get_frame_len(void) const { return frame_len; }
        
        int get_len_mpa_frame(void) const { return len_mpa_frame; }
        
        int get_fade_in_mode(void) const { return fade_in_mode; }
        int get_frames_fade_in(void) const { return frames_fade_in; }
        int get_fade_out_mode(void) const { return fade_out_mode; }
        int get_frames_fade_out(void) const { return frames_fade_out; }
        
        char *get_path(void) const { return path; }
        char *get_new_path(void) const { return new_path; }
        
        cPostData *get_next(void) { return next; }
        void set_next(cPostData *postdata) { next = postdata; }
};

#endif /* __POSTDATA_H */
