/*
 * postproc.h
 */

#ifndef __POSTPROC_H
#define __POSTPROC_H

#include "convert.h"
#include "postdata.h"
#include "mpa-frame.h"
#include "a-tools.h"

#include <vdr/thread.h>

#include <stdio.h>

class cPostproc : public cThread {
private:
        cPostData *postdata;
        cPostData *postdata_tail;
        abuffer file_buf;
        mpeg_audio_frame mpa_frame;
        cConvert *convert;
        int num_queued;
        
        void reencode(void);
        void fade_in(void);
        void fade_out(void);
        float get_volume(int _frame, int _frames);
#ifdef TAGLIB
        void set_tag();
#endif /* TAGLIB */
        void rename_file(void);
        void set_next_postdata(void);
protected:
        virtual void Action(void);
        virtual void Activate(bool on);
public:
        cPostproc(void);
        ~cPostproc();
        
        void put_postdata(const cPostData *_postdata);
        int get_num_queued() { return num_queued; }
};

extern cPostproc Postproc;

#endif /* __POSTPROC_H */
