/*
 * rds.h
 */

#ifndef __RDS_H
#define __RDS_H

#include "recstat.h"
#include "postdata.h"
#include "a-tools.h"

#define RDS_BUF_SIZE 263*2

enum eMec {
        mecNone,
        mecPTY = 0x07,
        mecRT  = 0x0a,
        mecODA = 0x46
};

enum {
        ItemTitle = 1,
        ItemAlbum,
        ItemTracknr,
        ItemArtist,
        ItemComposition,
        ItemMovement,
        ItemComposer,
        ItemBand,
        ItemComment,
        ItemGenre
};

class cRds {
private:
        abuffer buf, rds_frame;
        char radiotext[65];
        int rt_length;
        bool lb0xfd;
        int last_tb, last_rb;
        char *channel_name;
        eRecStat recstat;
        
        cPostData *postdata;
        
        void decode_radiotext(void);
        void decode_rtp(void);
        void decode_rtp_items(void);
        bool correct_rtp_tag(int &type, int &start, int &length);
        void delete_data(int length);
        
        void print_buffer(void);
public:
        cRds(const char *_channel_name, cPostData *_postdata);
        ~cRds();
        
        void put_data(uchar *data, int length);
        bool set_next_frame(void);
        eRecStat decode_frame(void);
};

#endif /* __RDS_H */
