/*
 * track.c
 */

#include "track.h"
#include "a-tools.h"

#include <vdr/tools.h>

/* --- cTrack -------------------------------------------------------------- */

cTrack::cTrack()
{
	path = NULL;
        file = NULL;
}


cTrack::~cTrack(void)
{
  	/* remove unfinished recordings */
  	if (file && path)
                remove(path);
        
 	FREE(path);
 	FCLOSE(file);
}


void cTrack::new_track(char *_path)
{
        FREE(path);
        
	if (! _path)
                return;
        
        path = strdup0(_path);
	file = fopen(path, "w");
        
      	dsyslog("[audiorecorder]: started new track (%s) (%s, %s())", path,
                __FILE__, __func__);
}


void cTrack::write_data(uchar *data, int length)
{
	if (file && data && length > 0) 
		fwrite(data, sizeof(uchar), length, file);
}


void cTrack::stop_track(void)
{
	FCLOSE(file);
        
        if (! path)
                return;
        
	dsyslog("[audiorecorder]: finished track (%s) (%s, %s())", path,
                __FILE__, __func__);
}


void cTrack::delete_track(void)
{
        if (! path)
                return;
        
	remove(path);
	dsyslog("[audiorecorder]: track deleted (%s) (%s, %s())", path,
                __FILE__, __func__);
}
